package sorting.views;

import java.awt.Color;
import java.awt.Graphics;

import javax.swing.ListSelectionModel;

import sorting.model.*;
import sorting.observer.ObserverInterface;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author  Theodore Norvell
 * @version 1.0
 */

public class Histogram extends AbsPanelViewOfArray
                       implements ObserverInterface {
    
    private static final long serialVersionUID = -3276958395051347839L;
	public Histogram( ObservableArray array ) {
		super( array ) ;}
 

    
    @Override
	protected Runnable getUpdater() {
		return new Runnable() {
			@Override public void run() {
		    	repaint() ; }
			};
	}
        
    @Override public void paintComponent( Graphics g ) {
        int length = array.length() ;
        int height = array.getHeight()  ;
        int myHeight = getHeight() ;
        int myWidth = getWidth() ;
        
        g.setColor(Color.lightGray);
        g.fillRect(0, 0, myWidth, myHeight);
        
        if( myWidth <= 0 || myHeight <= 0 ) return ;
        
        int rectWidth = myWidth / length ; 
        int x = 0 ; 
        for( int i = 0 ; i < length ; ++i ) {
        	switch( array.getHighlight(i) ) {
        	case RED : {
                g.setColor( Color.red ) ; }
        	break ;
        	case BLUE : {
                g.setColor( Color.blue ) ; }
        	break ;
        	case WHITE : {
                g.setColor( Color.white ) ; }
        	break ;
            default : {
                g.setColor( Color.black ); } }
            int rectHeight = array.get(i)*myHeight / height ;
            g.fillRect(x, myHeight-rectHeight, rectWidth-5, rectHeight);
            x += rectWidth ; }
    }
}       