package sorting.views;

import java.awt.BorderLayout;

import javax.swing.DefaultListModel;
import javax.swing.JList;
import javax.swing.JScrollPane;
import javax.swing.ListSelectionModel;

import sorting.model.*;
import sorting.observer.ObserverInterface;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author  Theodore Norvell
 * @version 1.0
 */

public class ListViewOfArray extends AbsPanelViewOfArray
                             implements ObserverInterface {
    
    private static final long serialVersionUID = 6016429154671814468L;
	private JScrollPane scrollPane ;
    private JList<Integer> jList ;
    private DefaultListModel<Integer> listModel ;
    
    public ListViewOfArray( ObservableArray array ) {
    	super( array ) ;
        this.setLayout( new BorderLayout() ) ;
        scrollPane = new JScrollPane() ;
        this.add( scrollPane ) ;
        listModel = new DefaultListModel<Integer> () ;
        jList = new JList<Integer> () ;
        jList.setModel(listModel) ;
        jList.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION ) ;	
        scrollPane.setViewportView(jList) ; }
        
    @Override
    protected Runnable getUpdater() {
		return new Runnable() {
			@Override public void run() {
		    	listModel.clear() ;
		        jList.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION ) ;
		        for( int i = 0 ; i < array.length() ; ++i ) {
		        	listModel.add(i, array.get(i) ) ;
		        	switch( array.getHighlight(i)) {
		        	case BLUE: case RED: jList.addSelectionInterval(i, i) ;
					default: } } }
			};
	}
}